## sentencepiece 0.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: sentencepiece
 Type: Package
 Title: Text Tokenization using Byte Pair Encoding and Unigram Modelling
-Version: 0.1.1
+Version: 0.1.2
 Authors@R: c(
     person('Jan', 'Wijffels', role = c('aut', 'cre', 'cph'), email = 'jwijffels@bnosac.be', comment = "R wrapper"), 
     person('BNOSAC', role = 'cph', comment = "R wrapper"), 
@@ -38,7 +38,7 @@
 Suggests: tokenizers.bpe
 LinkingTo: Rcpp
 NeedsCompilation: yes
-Packaged: 2020-05-29 19:27:35 UTC; Jan
+Packaged: 2020-06-05 10:47:10 UTC; Jan
 Author: Jan Wijffels [aut, cre, cph] (R wrapper),
   BNOSAC [cph] (R wrapper),
   Google Inc. [ctb, cph] (Files at src/sentencepiece/src (Apache License,
@@ -122,4 +122,4 @@
     data/models/nl.wiki.bpe.vs1000.d25.w2v.txt and
     data/models/nl.wiki.bpe.vs1000.model (MIT License))
 Repository: CRAN
-Date/Publication: 2020-06-04 10:10:03 UTC
+Date/Publication: 2020-06-08 21:40:02 UTC
