=== debian/changelog ===
sentencepiece (0.1.83-1) unstable; urgency=medium

  * Initial release

 -- Kentaro Hayashi <hayashi@clear-code.com>  Fri, 23 Aug 2019 18:27:54 +0900
