## sentencepiece 0.1.84

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,10 +70,6 @@
   set(CMAKE_INSTALL_LIBDIR lib)
 endif()
 
-if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
-  set(CMAKE_INSTALL_LIBDIR lib)
-endif()
-
 if (NOT DEFINED CMAKE_INSTALL_INCDIR)
   set(CMAKE_INSTALL_INCDIR include)
 endif()
