=== debian/changelog ===
sentencepiece (0.1.84-1build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:25:45 +0100

sentencepiece (0.1.84-1) unstable; urgency=medium

  * New upstream version 0.1.84 (Closes: #939860)

  [ TSUCHIYA Masatoshi ]
  * Initial packaging tasks.
  * Remove pipeline configurations for BitBucket.

  [ Kentaro Hayashi ]
  * debian/gbp.conf
    - Add basic configuration about debian-branch
  * debian/watch
    - Add missing watch file to detect a new release
  * debian/control
    - Update deprecated Priority: to optional
    - Add Vcs-* fields
    - Fix W: sentencepiece: description-synopsis-starts-with-article
    - Bump standard version to 4.4.1
    - Update Vcs-* under science-team
    - Bump up compatibility level
    - Drop python2 support
  * debian/copyright
    - Use https://
    - Update copyright about third party modules
  * debian/rules
    - Enable hardening
  * debian/salsa-ci.yml
    - Add Salsa CI configuration

 -- Kentaro Hayashi <hayashi@clear-code.com>  Thu, 17 Oct 2019 13:33:34 +0900
