=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake
	dh_auto_configure --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	dh_auto_build --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_install: basedir=$(shell pwd)/debian
override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	dh_auto_install --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake
	-rm -rf .pybuild
	-rm -rf .python/sentencepiece.egg-info

# Do no tests.
override_dh_auto_test:
