=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%sentencepiece-$1-Source.tar.xz%" \
   https://github.com/google/sentencepiece/tags \
   (?:.*?/)?v(\d[\d.]*)\.tar\.gz debian uupdate
