=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,17 +20,18 @@
   set(PROTOBUF_LITE_LIBRARY "")
   set(PROTOBUF_LITE_SRCS
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arena.cc
-    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arenastring.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/bytestream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/coded_stream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/common.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/extension_set.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_enum_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_table_driven_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/implicit_weak_message.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/int128.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/io_win32.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/message_lite.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/parse_context.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/repeated_field.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/status.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/statusor.cc
@@ -41,6 +42,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/time.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/wire_format_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl_lite.cc)
   if (MSVC)
     add_definitions("/DHAVE_PTHREAD /wd4018 /wd4514")
@@ -59,6 +61,12 @@
 endif()
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
+
+if (MSVC)
+  add_definitions("/D_USE_INTERNAL_STRING_VIEW")
+else()
+  add_definitions("-D_USE_INTERNAL_STRING_VIEW")
+endif()
 
 set(SPM_SRCS
   ${PROTOBUF_LITE_SRCS}
@@ -72,7 +80,7 @@
   util.h
   freelist.h
   filesystem.h
-  flags.h
+  init.h
   sentencepiece_processor.h
   word_model.h
   model_factory.h
@@ -84,7 +92,7 @@
   char_model.cc
   error.cc
   filesystem.cc
-  flags.cc
+  init.cc
   model_factory.cc
   model_interface.cc
   normalizer.cc
@@ -92,7 +100,8 @@
   unigram_model.cc
   util.cc
   word_model.cc
-  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/strings/string_view.cc)
+  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/strings/string_view.cc
+  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/flags/flag.cc)
 
 set(SPM_TRAIN_SRCS
   ${SPM_PROTO_HDRS}
@@ -108,6 +117,7 @@
   char_model_trainer.h
   bpe_model_trainer.h
   sentencepiece_trainer.h
+  pretokenizer_for_training.h
   builder.cc
   unicode_script.cc
   trainer_factory.cc
@@ -116,7 +126,8 @@
   word_model_trainer.cc
   char_model_trainer.cc
   bpe_model_trainer.cc
-  sentencepiece_trainer.cc)
+  sentencepiece_trainer.cc
+  pretokenizer_for_training.cc)
 
 set(SPM_TEST_SRCS
   ${SPM_PROTO_HDRS}
@@ -128,7 +139,7 @@
   char_model_test.cc
   char_model_trainer_test.cc
   filesystem_test.cc
-  flags_test.cc
+  init_test.cc
   model_factory_test.cc
   model_interface_test.cc
   normalizer_test.cc
@@ -143,7 +154,8 @@
   unigram_model_trainer_test.cc
   util_test.cc
   word_model_test.cc
-  word_model_trainer_test.cc)
+  word_model_trainer_test.cc
+  pretokenizer_for_training_test.cc)
 
 find_package(Threads REQUIRED)
 
@@ -273,13 +285,13 @@
   include(Dart)
 
   add_test(NAME sentencepiece_test
-    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir})
+    COMMAND $<TARGET_FILE:spm_test> --test_srcdir=${data_dir})
 endif()
 
 if (SPM_COVERAGE)
   add_custom_target(coverage
     COMMAND mkdir -p coverage
-    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir}
+    COMMAND $<TARGET_FILE:spm_test> --test_srcdir=${data_dir}
     COMMAND lcov -c -d . -o coverage.info
     COMMAND lcov --remove coverage.info "include*" "/c++" "_test*" "testharness*" "third_party*" ".pb.*" -o coverage.info
     COMMAND mkdir -p lcov_html
