=== debian/changelog ===
sentencepiece (0.1.92-1) unstable; urgency=medium

  * New upstream version 0.1.92

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 19 Jun 2020 19:38:49 +0900

sentencepiece (0.1.91-1) unstable; urgency=medium

  * New upstream version 0.1.91

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 22 May 2020 15:17:42 +0900

sentencepiece (0.1.90-3) unstable; urgency=medium

  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Refresh patch to fix FTBFS.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 17 May 2020 09:02:23 +0900

sentencepiece (0.1.90-2) unstable; urgency=medium

  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Add patch to fix FTBFS on mipsel and armel

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 16 May 2020 16:16:45 +0900

sentencepiece (0.1.90-1) unstable; urgency=medium

  * New upstream version 0.1.90
  * debian/control
    - Update Uploaders:
    - Bump standard-version to 4.5.0
    - Bump compat version to 13.
  * debian/source/lintian-overrides
    - Fix false positive source-is-missing
  * debian/patches/0003-Disable-static-library-explicitly.patch
    - Disable to build static library

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 13 May 2020 19:09:34 +0900
