=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
   TSUCHIYA Masatoshi <tsuchiya@namazu.org>,
-  Kentaro Hayashi <hayashi@clear-code.com>
+  Kentaro Hayashi <kenhys@xdump.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  protobuf-compiler,
  libprotobuf-dev,
  dh-python,
@@ -14,7 +14,7 @@
  quilt,
  cmake,
  python3-setuptools
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/sentencepiece
 Vcs-Browser: https://salsa.debian.org/science-team/sentencepiece
 Vcs-Git: https://salsa.debian.org/science-team/sentencepiece.git
