## sentencepiece 0.1.93

=== debian/changelog ===
sentencepiece (0.1.93-1) unstable; urgency=medium

  * New upstream version 0.1.93
  * debian/source/lintian-overrides
    - Remove needless override.

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 15 Oct 2020 21:32:05 +0900

sentencepiece (0.1.92-3) unstable; urgency=medium

  * debian/patches/fix-ftbfs-ports.patch
    - Fix FTBFS on powerpc

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 03 Oct 2020 20:48:27 +0900

sentencepiece (0.1.92-2) unstable; urgency=medium

  * debian/patches/0002-Change-in-order-to-build-Python-modules-in-place.patch
    - Fix FTBFS on hurd-i386
  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Fix missing dependency to atomic library (powerpc,m68k,sh4)

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 26 Sep 2020 20:27:17 +0900
