=== debian/changelog ===
sentencepiece (0.1.94-2) unstable; urgency=medium

  * Fix FTBFS on armel/mipsel (Closes: #977235)

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 16 Dec 2020 21:18:15 +0900

sentencepiece (0.1.94-1) unstable; urgency=medium

  * New upstream version 0.1.94
  * debian/patches/support-python-module-in-place.patch
    - Refresh path to build python module.
  * debian/patches/fix-ftbfs-ports.patch
    debian/patches/mutiarch-support.patch
    - Remove needless patch because these patch was merged
      to google/sentencepiece.

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 28 Oct 2020 21:02:07 +0900
